--- a/Makefile
+++ b/Makefile
@@ -27,23 +27,23 @@
 	if test -r $*.ch; then cweave $*.w $*.ch; else cweave $*.w; fi
 
 .w.o:
-	make $*.c
-	make $*.o
+	$(MAKE) $*.c
+	$(MAKE) $*.o
 
 .w:
-	make $*.c
-	make $*
+	$(MAKE) $*.c
+	$(MAKE) $*
 
 .w.dvi:
-	make $*.tex
-	make $*.dvi
+	$(MAKE) $*.tex
+	$(MAKE) $*.dvi
 
 .w.ps:
-	make $*.dvi
-	make $*.ps
+	$(MAKE) $*.dvi
+	$(MAKE) $*.ps
 
 .w.pdf:
-	make $*.tex
+	$(MAKE) $*.tex
 	case "$(PDFTEX)" in \
 	 dvipdfm ) tex "\let\pdf+ \input $*"; dvipdfm $* ;; \
 	 pdftex ) pdftex $* ;; \
@@ -73,27 +73,26 @@
 clean:
 	rm -f *~ *.o *.c *.h *.tex *.log *.dvi *.toc *.idx *.scn *.ps core
 
-mmix-pipe.o: mmix-pipe.c abstime
+abstime.h: abstime
 	./abstime > abstime.h
+
+mmix-pipe.o: mmix-pipe.c abstime abstime.h
 	$(CC) $(CFLAGS) -c mmix-pipe.c
-	rm abstime.h
 
 mmix-config.o: mmix-pipe.o
 
 mmmix:  mmix-arith.o mmix-pipe.o mmix-config.o mmix-mem.o mmix-io.o mmmix.c
-	$(CC) $(CFLAGS) mmmix.c \
+	$(CC) $(CFLAGS) $(LDFLAGS) mmmix.c \
 	  mmix-arith.o mmix-pipe.o mmix-config.o mmix-mem.o mmix-io.o -o mmmix
 
 mmixal: mmix-arith.o mmixal.c
-	$(CC) $(CFLAGS) mmixal.c mmix-arith.o -o mmixal
+	$(CC) $(CFLAGS) $(LDFLAGS) mmixal.c mmix-arith.o -o mmixal
 
-mmix:   mmix-arith.o mmix-io.o mmix-sim.c abstime
-	./abstime > abstime.h
-	$(CC) $(CFLAGS) mmix-sim.c mmix-arith.o mmix-io.o -o mmix
-	rm abstime.h
+mmix:   mmix-arith.o mmix-io.o mmix-sim.c abstime abstime.h
+	$(CC) $(CFLAGS) $(LDFLAGS) mmix-sim.c mmix-arith.o mmix-io.o -o mmix
 
 mmotype: mmotype.c
-	$(CC) $(CFLAGS) mmotype.c -o mmotype
+	$(CC) $(CFLAGS) $(LDFLAGS) mmotype.c -o mmotype
 
 tarfile: $(ALL)
 	tar cvf /tmp/mmix.tar $(ALL)
